/************************************************************************************
dijkstrairs
Copyright (c) 2010, International Rescue System Institute
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD license.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/

//***********************************************************************************************//
//* main.cpp									     2010.02.06 *//
//*												*//
//* GTK+ モニタリングプログラム									*//
//***********************************************************************************************//


//-- [ヘッダファイル] ---------------------------------------------------------------------------//
#include <stdlib.h>											// stdlibヘッダファイル読み込み
#include <gtk/gtk.h>											// gtk/gtkヘッダファイル読み込み
#include <glade/glade.h>										// glade/gladeヘッダファイル読み込み
#include "udp.h"											// udpヘッダファイル読み込み
//-----------------------------------------------------------------------------------------------//

//-- [置換] -------------------------------------------------------------------------------------//
#define BUFSIZE		128										// 最大送受信文字数
#define DATASIZE	256										// 最大データ文字数
#define FONTSTYLE	"Liberation Sans"								// フォントスタイル
#define DEBUG_COMMAND_LINE										// DEBUG定義 [デバッグ用]
#define DEBUG_MAPDATA											// DEBUG定義 [デバッグ用]
//-----------------------------------------------------------------------------------------------//


//-- [コールバック関数プロトタイプ宣言] ---------------------------------------------------------//
G_BEGIN_DECLS
void udp_read_callback(gpointer, gint, GdkInputCondition);						// UDPデータ受信イベント
gboolean drawingarea_expose_event(GtkWidget*, GdkEventExpose*, gpointer);				// エクスポーズイベント
void window_destroy(GtkWidget*);									// ウィンドウ破棄イベント
G_END_DECLS
//-----------------------------------------------------------------------------------------------//


//-- [変数宣言] ---------------------------------------------------------------------------------//
char *precv;												// 送信データ格納ポインタ
char send_data[BUFSIZE];										// 送信データ格納配列
char recv_data[12 * BUFSIZE];										// 受信データ格納配列
int recv_flag;												// フラグ格納変数
int send_sock;												// ソケットディスクリプタ格納変数
int recv_sock;												// ソケットディスクリプタ格納変数
int recv_len;												// 受信サイズ格納変数
int recv_num;												// 受信番号格納変数
unsigned long int recv_size;										// 受信最大サイズ格納変数
unsigned long square[4];										// 矩形データ格納配列
unsigned long int size_x;										// x座標ピクセル数格納変数
unsigned long int size_y;										// y座標ピクセル数格納変数
struct sockaddr_in send_addr;										// アドレス格納構造体
struct sockaddr_in recv_addr;										// アドレス格納構造体
socklen_t addr_size;											// アドレス格納構造体サイズ格納変数
GtkWidget *drawingarea;											// 画像 [drawingarea]
GtkWidget *explanation;											// ラベル [explanation]
GtkWidget *location;											// ラベル [location]
GtkWidget *timestamp;											// ラベル [timestamp]
GtkWidget *mode;											// ラベル [mode]
GtkWidget *mapset;											// ラベル [mapset]
GtkWidget *type;											// ラベル [type]
GtkWidget *originx;											// ラベル [originx]
GtkWidget *originy;											// ラベル [originy]
GtkWidget *sizex;											// ラベル [sizex]
GtkWidget *sizey;											// ラベル [sizey]
GtkWidget *maporiginx;											// ラベル [maporiginx]
GtkWidget *maporiginy;											// ラベル [maporiginy]
GtkWidget *mapsizex;											// ラベル [mapsizex]
GtkWidget *mapsizey;											// ラベル [mapsizey]
GtkWidget *pixelsizex;											// ラベル [pixelsizex]
GtkWidget *pixelsizey;											// ラベル [pixelsizey]
GtkWidget *category1;											// ラベル [category1]
GtkWidget *category2;											// ラベル [category2]
GtkWidget *category3;											// ラベル [category3]
GtkWidget *category4;											// ラベル [category4]
GdkPixbuf *pixbuf;											// バッファ [pixbuf]
GdkColor color;												// 色 [color]
//-----------------------------------------------------------------------------------------------//


//-- [UDPデータ受信イベント] --------------------------------------------------------------------//
//- void udp_read_callback(gpointer data, gint source, GdkInputCondition condition)		-//
//- 機能  ：UDPのデータ受信処理を行う								-//
//- 引数  ：(gpointer)          関数引き渡しユーザデータ [gtk_input_add, gtk_input_add_full]	-//
//-       ：(gint)              条件が発生するファイルディスクリプタ				-//
//-       ：(GdkInputCondition) トリガー条件							-//
//- 戻り値：(void)              なし								-//
//-----------------------------------------------------------------------------------------------//
void udp_read_callback(gpointer data, gint source, GdkInputCondition condition)
{


	//-- [変数宣言] -------------------------------------------------------------------------//

	unsigned long int i;										// カウンタ格納変数
	unsigned long int j;										// カウンタ格納変数
	unsigned long int k;										// カウンタ格納変数
	unsigned long int width;									// 画像幅格納変数
	unsigned long int height;									// 画像高さ格納変数
	unsigned long int rowstride;									// 一行サイズ格納変数
	int ratio;											// 比率格納変数
	char message[18][DATASIZE];									// メッセージ格納配列
	char label[17][DATASIZE];									// ラベル格納配列
	guchar *pixels;											// ピクセルデータ格納ポインタ

	//---------------------------------------------------------------------------------------//


	//-- [初期化] ---------------------------------------------------------------------------//

	for(i = 0; i < 18; i++) strcpy(message[i], "");							// メッセージ初期化

	//---------------------------------------------------------------------------------------//


	//-- [受信データクリア] -----------------------------------------------------------------//

	memset(recv_data, 0, sizeof(recv_data));							// バッファクリア

	//---------------------------------------------------------------------------------------//


	//-- [受信処理] -------------------------------------------------------------------------//


	//-- [パラメータ受信] -------------------------------------------------------------------//

	if(recv_flag == 0){										// パラメータ受信

		recv_len = recvfrom(recv_sock, recv_data, sizeof(recv_data), 0,
			(struct sockaddr *)&recv_addr, &addr_size);					// データ受信

		if(recv_len < 0){

			printf("receive error!!\n");							// メッセージ表示
			fflush(stdout);									// バッファフラッシュ [printf表示用]

		}

		j = 0;											// カウンタリセット
		k = 0;											// カウンタリセット

		for(i = 0; i < (unsigned long int)recv_len; i++){

			if(recv_data[i] != ','){

				message[k][j] = recv_data[i];						// データ格納
				j++;									// カウント

			}else{

				message[k][j] = 0x00;							// 終端文字処理
				j = 0;									// カウンタリセット
				k++;									// カウント

			}

		}

		message[k][j] = 0x00;									// 終端文字処理

		//-------------------------------------------------------------------------------//


		//-- [プログラム終了処理] -------------------------------------------------------//

		if(strcmp("quit", recv_data) == 0){

			close(send_sock);								// ソケットディスクリプタクローズ
			close(recv_sock);								// ソケットディスクリプタクローズ
			gtk_main_quit();								// メッセージループ回避

		//-------------------------------------------------------------------------------//


		//-- [ラベル処理] ---------------------------------------------------------------//

		}else{


			//-- [ラベル表示処理] ---------------------------------------------------//

			strcpy(label[10], ": ");							// コロン
			strcat(label[10], message[10]);							// 地図説明
			gtk_label_set_text((GtkLabel *)explanation, label[10]);				// ラベル表示 [explanation]

			strcpy(label[3], ": ");								// コロン
			strcat(label[3], message[3]);							// 地域名
			gtk_label_set_text((GtkLabel *)location, label[3]);				// ラベル表示 [location]

			strcpy(label[0], ": ");								// コロン
			strcat(label[0], message[0]);							// タイムスタンプ [sec]
			strcat(label[0], ".");								// ドット
			strcat(label[0], message[1]);							// タイムスタンプ [nsec]
			gtk_label_set_text((GtkLabel *)timestamp, label[0]);				// ラベル表示 [timestamp]

			strcpy(label[2], ": ");								// コロン
			strcat(label[2], message[2]);							// アクセスモード
			gtk_label_set_text((GtkLabel *)mode, label[2]);					// ラベル表示 [mode]

			strcpy(label[4], ": ");								// コロン
			strcat(label[4], message[4]);							// 利用者マップセット名
			gtk_label_set_text((GtkLabel *)mapset, label[4]);				// ラベル表示 [mapset]

			strcpy(label[5], ": ");								// コロン
			strcat(label[5], message[5]);							// データタイプ
			gtk_label_set_text((GtkLabel *)type, label[5]);					// ラベル表示 [type]

			strcpy(label[6], ": ");								// コロン
			strcat(label[6], message[6]);							// 対象原点x座標
			gtk_label_set_text((GtkLabel *)originx, label[6]);				// ラベル表示 [originx]

			strcpy(label[7], ": ");								// コロン
			strcat(label[7], message[7]);							// 対象原点y座標
			gtk_label_set_text((GtkLabel *)originy, label[7]);				// ラベル表示 [originy]

			strcpy(label[8], ": ");								// コロン
			strcat(label[8], message[8]);							// 対象範囲x座標
			gtk_label_set_text((GtkLabel *)sizex, label[8]);				// ラベル表示 [sizex]

			strcpy(label[9], ": ");								// コロン
			strcat(label[9], message[9]);							// 対象範囲y座標
			gtk_label_set_text((GtkLabel *)sizey, label[9]);				// ラベル表示 [sizey]

			strcpy(label[11], ": ");							// コロン
			strcat(label[11], message[11]);							// 地図原点x座標
			gtk_label_set_text((GtkLabel *)maporiginx, label[11]);				// ラベル表示 [maporiginx]

			strcpy(label[12], ": ");							// コロン
			strcat(label[12], message[12]);							// 地図原点y座標
			gtk_label_set_text((GtkLabel *)maporiginy, label[12]);				// ラベル表示 [maporiginy]

			strcpy(label[13], ": ");							// コロン
			strcat(label[13], message[13]);							// 地図サイズx座標
			gtk_label_set_text((GtkLabel *)mapsizex, label[13]);				// ラベル表示 [mapsizex]

			strcpy(label[14], ": ");							// コロン
			strcat(label[14], message[14]);							// 地図サイズy座標
			gtk_label_set_text((GtkLabel *)mapsizey, label[14]);				// ラベル表示 [mapsizey]

			strcpy(label[15], ": ");							// コロン
			strcat(label[15], message[15]);							// ピクセルサイズx座標
			gtk_label_set_text((GtkLabel *)pixelsizex, label[15]);				// ラベル表示 [pixelsizex]

			strcpy(label[16], ": ");							// コロン
			strcat(label[16], message[16]);							// ピクセルサイズy座標
			gtk_label_set_text((GtkLabel *)pixelsizey, label[16]);				// ラベル表示 [pixelsizey]

			recv_size = atol(message[17]);							// 地図情報サイズ格納
			precv = (char*)calloc(recv_size, sizeof(char));					// メモリ確保

			//-----------------------------------------------------------------------//

			size_x = atol(message[8]) / atol(message[15]);					// ピクセル数格納
			size_y = atol(message[9]) / atol(message[16]);					// ピクセル数格納
			recv_flag = 1;									// フラグチェック

		}

		//-------------------------------------------------------------------------------//


	//---------------------------------------------------------------------------------------//


	//-- [地図情報受信] ---------------------------------------------------------------------//

	}else{

		recv_len = recvfrom(recv_sock, precv + size_x * recv_num, size_x, 0,
			(struct sockaddr *)&recv_addr, &addr_size);					// データ受信

		if(recv_len < 0){

			printf("receive error!!\n");							// メッセージ表示
			fflush(stdout);									// バッファフラッシュ [printf表示用]

		}

		recv_num++;										// 受信番号カウント


		//-- [画像処理] -----------------------------------------------------------------//

		if(recv_num == (int)size_y){								// 受信チェック


			//-- [デバッグmapdata] --------------------------------------------------//

			#ifndef DEBUG_MAPDATA								// デバッグ表示開始

				printf("\n[mapdata]\n");						// label

				for(i = 0; i < size_y; i++){

					for(j = 0; j < size_x; j++)
						printf("%c", *(precv + size_x * i + j));		// mapdata

					printf("\n");							// 改行表示

				}

				printf("\n");								// 改行表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

			#endif										// デバッグ表示終了

			//-----------------------------------------------------------------------//


			//-- [プログラム終了処理] -----------------------------------------------//

			if(strcmp("quit", recv_data) == 0){

			close(send_sock);								// ソケットディスクリプタクローズ
			close(recv_sock);								// ソケットディスクリプタクローズ
			gtk_main_quit();								// メッセージループ回避

			//-----------------------------------------------------------------------//


			//-- [画像処理] ---------------------------------------------------------//

			}else{

				//-- [画像描画] -------------------------------------------------//

				pixbuf =
					gdk_pixbuf_new(GDK_COLORSPACE_RGB, FALSE, 8, size_x, size_y);	// バッファ生成 [pixbuf]

				width     = gdk_pixbuf_get_width(pixbuf);				// 画像幅格納
				height    = gdk_pixbuf_get_height(pixbuf);				// 画像高さ格納
				rowstride = gdk_pixbuf_get_rowstride(pixbuf);				// 一行サイズ格納
				pixels   = gdk_pixbuf_get_pixels(pixbuf);				// ピクセルデータアドレス格納

				for(i = 0; i < height; i++){

					for(j = 0; j < width; j++){

						if(*(precv + width * i + j) == 0x31){			// SAFETY

							pixels[(rowstride * i) + j * 3    ] = 0xff;	// RED設定
							pixels[(rowstride * i) + j * 3 + 1] = 0xff;	// GREEN設定
							pixels[(rowstride * i) + j * 3 + 2] = 0xff;	// BLUE設定

						}else if(*(precv + width * i + j) == 0x32){		// HAZARD

							pixels[(rowstride * i) + j * 3    ] = 0x00;	// RED設定
							pixels[(rowstride * i) + j * 3 + 1] = 0x00;	// GREEN設定
							pixels[(rowstride * i) + j * 3 + 2] = 0x00;	// BLUE設定

						}else if(*(precv + width * i + j) == 0x33){		// START/END

							pixels[(rowstride * i) + j * 3    ] = 0xff;	// RED設定
							pixels[(rowstride * i) + j * 3 + 1] = 0x00;	// GREEN設定
							pixels[(rowstride * i) + j * 3 + 2] = 0x00;	// BLUE設定

						}else{							// PATH

							pixels[(rowstride * i) + j * 3    ] = 0x00;	// RED設定
							pixels[(rowstride * i) + j * 3 + 1] = 0x00;	// GREEN設定
							pixels[(rowstride * i) + j * 3 + 2] = 0xff;	// BLUE設定

						}

					}

				}

				if(gdk_pixbuf_get_width(pixbuf) > gdk_pixbuf_get_height(pixbuf))
					ratio = (gdk_pixbuf_get_width(pixbuf)
						/ drawingarea->allocation.width) + 1;			// 比率格納
				else ratio = (gdk_pixbuf_get_height(pixbuf)
						/ drawingarea->allocation.height) + 1;			// 比率格納

				pixbuf = gdk_pixbuf_scale_simple(pixbuf,
					(gdk_pixbuf_get_width(pixbuf)) / ratio,
					(gdk_pixbuf_get_height(pixbuf)) / ratio, GDK_INTERP_NEAREST);	// 画像比率変更

				gtk_widget_set_size_request(drawingarea, gdk_pixbuf_get_width(pixbuf),
					gdk_pixbuf_get_height(pixbuf));					// 画像サイズ設定

				//---------------------------------------------------------------//


				//-- [メモリ解放] -----------------------------------------------//

				free(precv);								// メモリ解放

				//---------------------------------------------------------------//


				recv_size = 0;								// 受信サイズ初期化
				recv_num  = 0;								// 受信番号初期化
				recv_flag = 0;								// フラグクリア

			}

			//-----------------------------------------------------------------------//


		}

		//-------------------------------------------------------------------------------//


	}

	//---------------------------------------------------------------------------------------//


}
//-----------------------------------------------------------------------------------------------//


//-- [エクスポーズイベント] ---------------------------------------------------------------------//
//- gboolean drawingarea_expose_event(GtkWidget *widget, GdkEventExpose *event, gpointer data)	-//
//- 機能  ：エクスポーズイベントの処理を行う							-//
//- 引数  ：(GtkWidget*)      シグナルを受けたオブジェクト [drawingarea]			-//
//-       ：(GdkEventExpose*) -									-//
//-       ：(gpointer)        シグナルハンドラ接続時にセットするユーザデータ			-//
//- 戻り値：(gboolean)        -									-//
//-----------------------------------------------------------------------------------------------//
gboolean drawingarea_expose_event(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{


	//-- [画像描画] -------------------------------------------------------------------------//

	if(pixbuf != NULL){

		gdk_draw_pixbuf(widget->window, NULL, pixbuf,
			0, 0, 0, 0,
			- 1, - 1, GDK_RGB_DITHER_NONE, 0, 0);						// 画像描画

	}

	//---------------------------------------------------------------------------------------//


	return TRUE;											// 戻り値 [正常終了]

}
//-----------------------------------------------------------------------------------------------//


//-- [ウィンドウ破棄イベント] -------------------------------------------------------------------//
//- void window_destroy(GtkWidget *widget)							-//
//- 機能  ：ウィンドウ破棄イベントの処理を行う							-//
//- 引数  ：(GtkWidget*) 破棄するオブジェクト							-//
//- 戻り値：(void)       なし									-//
//-----------------------------------------------------------------------------------------------//
void window_destroy(GtkWidget *widget)
{


	//-- [プログラム終了処理] ---------------------------------------------------------------//

	close(send_sock);										// ソケットディスクリプタクローズ
	close(recv_sock);										// ソケットディスクリプタクローズ
	gtk_main_quit();										// メッセージループ回避

	//---------------------------------------------------------------------------------------//


}
//-----------------------------------------------------------------------------------------------//


//-- [メイン関数] -------------------------------------------------------------------------------//
//- int main(int argc, char *argv[])								-//
//- 機能  ：(int)   コマンドライン引数の数							-//
//- 引数  ：(char*) コマンドライン引数								-//
//- 戻り値：(int)   -										-//
//-----------------------------------------------------------------------------------------------//
int main(int argc, char *argv[])
{


	//-- [変数宣言] -------------------------------------------------------------------------//

	// UDPプログラム
	char ip[16];											// IPアドレス格納配列
	char send_port[6];										// 送信ポート番号格納配列
	char recv_port[6];										// 受信ポート番号格納配列

	// GUIプログラム
	char xml_addr[DATASIZE];									// XMLファイルアドレス格納配列
	GladeXML *xml;											// GladeXML
	GtkWidget *window;										// トップレベルウィンドウ
	GtkWidget *explanationlabel;									// ラベル [explanationlabel]
	GtkWidget *locationlabel;									// ラベル [locationlabel]
	GtkWidget *timestamplabel;									// ラベル [timestamplabel]
	GtkWidget *modelabel;										// ラベル [modelabel]
	GtkWidget *mapsetlabel;										// ラベル [mapsetlabel]
	GtkWidget *typelabel;										// ラベル [typelabel]
	GtkWidget *originxlabel;									// ラベル [originxlabel]
	GtkWidget *originylabel;									// ラベル [originylabel]
	GtkWidget *sizexlabel;										// ラベル [sizexlabel]
	GtkWidget *sizeylabel;										// ラベル [sizeylabel]
	GtkWidget *maporiginxlabel;									// ラベル [maporiginxlabel]
	GtkWidget *maporiginylabel;									// ラベル [maporiginylabel]
	GtkWidget *mapsizexlabel;									// ラベル [mapsizexlabel]
	GtkWidget *mapsizeylabel;									// ラベル [mapsizeylabel]
	GtkWidget *pixelsizexlabel;									// ラベル [pixelsizexlabel]
	GtkWidget *pixelsizeylabel;									// ラベル [pixelsizeylabel]
	GtkWidget *categorylabel;									// ラベル [categorylabel]

	//---------------------------------------------------------------------------------------//


	//-- [コマンドライン引数処理] -----------------------------------------------------------//
	// 第1引数:	managementofareamap							-//
	// 第2引数:	[IPアドレス]								-//
	// 第3引数:	[送信ポート番号]	gui    -> module				-//
	// 第4引数:	[受信ポート番号]	module -> gui					-//
	//---------------------------------------------------------------------------------------//

	if(argc != 4){

		printf("argument error!!\n");								// メッセージ表示
		fflush(stdout);										// バッファフラッシュ [printf表示用]
		exit(1);										// 強制終了

	}else{

		strcpy(xml_addr, argv[0]);								// GUIプログラムアドレス取得
		strcpy(ip, argv[1]);									// IPアドレス取得
		strcpy(send_port, argv[2]);								// 送信ポート番号取得
		strcpy(recv_port, argv[3]);								// 受信ポート番号取得


		//-- [デバッグcommand line] ----------------------------------------------------//

		#ifndef DEBUG_COMMAND_LINE								// デバッグ表示開始

		printf("\n[command line]\n");								// label
		printf("command      = %s\n", xml_addr);						// command
		printf("ip           = %s\n", ip);							// ip
		printf("send port    = %s\n", send_port);						// send_port
		printf("receive port = %s\n\n", recv_port);						// recv_port
		fflush(stdout);										// バッファフラッシュ [printf表示用]

		#endif											// デバッグ表示終了

		//------------------------------------------------------------------------------//

		strcat(xml_addr, ".glade");								// XMLファイルアドレス取得

	}

	//---------------------------------------------------------------------------------------//


	//-- [初期化] ---------------------------------------------------------------------------//

	memset(send_data, 0, sizeof(send_data));							// 送信データ初期化
	memset(recv_data, 0, sizeof(recv_data));							// 受信データ初期化
	pixbuf    = NULL;										// バッファ初期化 [pixbuf]
	recv_flag = 0;											// フラグクリア
	recv_size = 0;											// 受信サイズ初期化
	recv_num  = 0;											// 受信番号初期化
	size_x    = 0;											// x座標ピクセル数初期化
	size_y    = 0;											// y座標ピクセル数初期化

	//---------------------------------------------------------------------------------------//


	//-- [データ格納] -----------------------------------------------------------------------//

	strcpy(send_data, "success");									// 送信データ設定

	//---------------------------------------------------------------------------------------//


	//-- [ソケット作成] ---------------------------------------------------------------------//
	//-											-//
	//- プロトコル・ファミリ								-//
	//- AF_UNIX, AF_LOCAL	: ローカル通信							-//
	//- AF_INET		: IPv4 インターネットプロトコル					-//
	//- AF_INET6		: IPv6 インターネットプロトコル					-//
	//- AF_IPX		: IPX-Novellプロトコル						-//
	//- AF_NETLINK		: カーネルユーザデバイス					-//
	//- AF_X25		: ITU-T X.25/ISO-8208プロトコル					-//
	//- AF_AX25		: アマチュア無線AX.25プロトコル					-//
	//- AF_ATMPVC		: ATMPVC							-//
	//- AF_APPLETALK	: アップルトーク						-//
	//- AF_PACKET		: 低レベルパケットインターフェース				-//
	//-											-//
	//- 通信方式										-//
	//- SOCK_STREAM		: バイトストリーム	[信頼性有:順序保証有:双方向]		-//
	//- SOCK_DGRAM		: データグラム		[信頼性無:固定最大長メッセージ]		-//
	//- SOCK_SEQPACKET	: データグラム		[信頼性有:固定最大長メッセージ:双方向]	-//
	//- SOCK_RAW		: 生ネットワーク						-//
	//- SOCK_RDM		: データグラム		[信頼性有:順序保証無]			-//
	//- SOCK_PACKET		: 廃止								-//
	//---------------------------------------------------------------------------------------//

	if((send_sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0){						// ソケット作成 [送信データ用]

		printf("socket error!!\n");								// メッセージ表示
		fflush(stdout);										// バッファフラッシュ [printf表示用]
		exit(1);										// 強制終了

	}

	if((recv_sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0){						// ソケット作成 [受信データ用]

		printf("socket error!!\n");								// メッセージ表示
		fflush(stdout);										// バッファフラッシュ [printf表示用]
		exit(1);										// 強制終了

	}

	//---------------------------------------------------------------------------------------//


	//-- [アドレス設定] ---------------------------------------------------------------------//

	send_addr.sin_family      = AF_INET;								// アドレスファミリ
	send_addr.sin_port        = htons(atoi(send_port));						// ポート番号 [バイトオーダ]
	send_addr.sin_addr.s_addr = inet_addr(ip);							// IPアドレス [バイトオーダ]

	recv_addr.sin_family      = AF_INET;								// アドレスファミリ
	recv_addr.sin_port        = htons(atoi(recv_port));						// ポート番号 [バイトオーダ]
	recv_addr.sin_addr.s_addr = inet_addr(ip);							// IPアドレス [バイトオーダ]

	//---------------------------------------------------------------------------------------//


	//-- [受信設定] -------------------------------------------------------------------------//

	bind(recv_sock, (struct sockaddr *)&recv_addr, sizeof(recv_addr));				// バインド [受信データ]
	addr_size = sizeof(recv_addr);									// アドレス格納構造体サイズ格納

	//---------------------------------------------------------------------------------------//


	//-- [GTK+初期化] -----------------------------------------------------------------------//

	gtk_init(&argc, &argv);										// GTK+初期化

	if(!(xml = glade_xml_new(xml_addr, NULL, NULL))){						// データ読み込み

		printf("glade file error.\n");								// メッセージ表示
		return 1;										// 戻り値 [異常終了]

	}


	//-- [ウィジェット生成] -----------------------------------------------------------------//

	window           = glade_xml_get_widget(xml, "window");						// ウィンドウ生成 [window]
	drawingarea      = glade_xml_get_widget(xml, "drawingarea");					// 画像生成 [drawingarea]
	explanationlabel = glade_xml_get_widget(xml, "explanationlabel");				// ラベル生成 [explanationlabel]
	locationlabel    = glade_xml_get_widget(xml, "locationlabel");					// ラベル生成 [locationlabel]
	timestamplabel   = glade_xml_get_widget(xml, "timestamplabel");					// ラベル生成 [timestamplabel]
	modelabel        = glade_xml_get_widget(xml, "modelabel");					// ラベル生成 [modelabel]
	mapsetlabel      = glade_xml_get_widget(xml, "mapsetlabel");					// ラベル生成 [mapsetlabel]
	typelabel        = glade_xml_get_widget(xml, "typelabel");					// ラベル生成 [typelabel]
	originxlabel     = glade_xml_get_widget(xml, "originxlabel");					// ラベル生成 [originxlabel]
	originylabel     = glade_xml_get_widget(xml, "originylabel");					// ラベル生成 [originylabel]
	sizexlabel       = glade_xml_get_widget(xml, "sizexlabel");					// ラベル生成 [sizexlabel]
	sizeylabel       = glade_xml_get_widget(xml, "sizeylabel");					// ラベル生成 [sizeylabel]
	maporiginxlabel  = glade_xml_get_widget(xml, "maporiginxlabel");				// ラベル生成 [maporiginxlabel]
	maporiginylabel  = glade_xml_get_widget(xml, "maporiginylabel");				// ラベル生成 [maporiginylabel]
	mapsizexlabel    = glade_xml_get_widget(xml, "mapsizexlabel");					// ラベル生成 [mapsizexlabel]
	mapsizeylabel    = glade_xml_get_widget(xml, "mapsizeylabel");					// ラベル生成 [mapsizeylabel]
	pixelsizexlabel  = glade_xml_get_widget(xml, "pixelsizexlabel");				// ラベル生成 [pixelsizexlabel]
	pixelsizeylabel  = glade_xml_get_widget(xml, "pixelsizeylabel");				// ラベル生成 [pixelsizeylabel]
	categorylabel    = glade_xml_get_widget(xml, "categorylabel");					// ラベル生成 [categorylabel]
	explanation      = glade_xml_get_widget(xml, "explanation");					// ラベル生成 [explanation]
	location         = glade_xml_get_widget(xml, "location");					// ラベル生成 [location]
	timestamp        = glade_xml_get_widget(xml, "timestamp");					// ラベル生成 [timestamp]
	mode             = glade_xml_get_widget(xml, "mode");						// ラベル生成 [mode]
	mapset           = glade_xml_get_widget(xml, "mapset");						// ラベル生成 [mapset]
	type             = glade_xml_get_widget(xml, "type");						// ラベル生成 [type]
	originx          = glade_xml_get_widget(xml, "originx");					// ラベル生成 [originx]
	originy          = glade_xml_get_widget(xml, "originy");					// ラベル生成 [originy]
	sizex            = glade_xml_get_widget(xml, "sizex");						// ラベル生成 [sizex]
	sizey            = glade_xml_get_widget(xml, "sizey");						// ラベル生成 [sizey]
	maporiginx       = glade_xml_get_widget(xml, "maporiginx");					// ラベル生成 [maporiginx]
	maporiginy       = glade_xml_get_widget(xml, "maporiginy");					// ラベル生成 [maporiginy]
	mapsizex         = glade_xml_get_widget(xml, "mapsizex");					// ラベル生成 [mapsizex]
	mapsizey         = glade_xml_get_widget(xml, "mapsizey");					// ラベル生成 [mapsizey]
	pixelsizex       = glade_xml_get_widget(xml, "pixelsizex");					// ラベル生成 [pixelsizex]
	pixelsizey       = glade_xml_get_widget(xml, "pixelsizey");					// ラベル生成 [pixelsizey]
	category1        = glade_xml_get_widget(xml, "category1");					// ラベル生成 [category1]
	category2        = glade_xml_get_widget(xml, "category2");					// ラベル生成 [category2]
	category3        = glade_xml_get_widget(xml, "category3");					// ラベル生成 [category3]
	category4        = glade_xml_get_widget(xml, "category4");					// ラベル生成 [category4]

	//---------------------------------------------------------------------------------------//


	//-- [フォント設定] ---------------------------------------------------------------------//

	gtk_widget_modify_font(explanationlabel, pango_font_description_from_string(FONTSTYLE));	// フォント設定 [explanationlabel]
	gtk_widget_modify_font(locationlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [locationlabel]
	gtk_widget_modify_font(timestamplabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [timestamplabel]
	gtk_widget_modify_font(modelabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [modelabel]
	gtk_widget_modify_font(mapsetlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [mapsetlabel]
	gtk_widget_modify_font(typelabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [typelabel]
	gtk_widget_modify_font(originxlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [originxlabel]
	gtk_widget_modify_font(originylabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [originylabel]
	gtk_widget_modify_font(sizexlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [sizexlabel]
	gtk_widget_modify_font(sizeylabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [sizeylabel]
	gtk_widget_modify_font(maporiginxlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [maporiginxlabel]
	gtk_widget_modify_font(maporiginylabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [maporiginylabel]
	gtk_widget_modify_font(mapsizexlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [mapsizexlabel]
	gtk_widget_modify_font(mapsizeylabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [mapsizeylabel]
	gtk_widget_modify_font(pixelsizexlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [pixelsizexlabel]
	gtk_widget_modify_font(pixelsizeylabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [pixelsizeylabel]
	gtk_widget_modify_font(categorylabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [categorylabel]
	gtk_widget_modify_font(explanation, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [explanation]
	gtk_widget_modify_font(location, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [location]
	gtk_widget_modify_font(timestamp, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [timestamp]
	gtk_widget_modify_font(mode, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [mode]
	gtk_widget_modify_font(mapset, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [mapset]
	gtk_widget_modify_font(type, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [type]
	gtk_widget_modify_font(originx, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [originx]
	gtk_widget_modify_font(originy, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [originy]
	gtk_widget_modify_font(sizex, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [sizex]
	gtk_widget_modify_font(sizey, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [sizey]
	gtk_widget_modify_font(maporiginx, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [maporiginx]
	gtk_widget_modify_font(maporiginy, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [maporiginy]
	gtk_widget_modify_font(mapsizex, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [mapsizex]
	gtk_widget_modify_font(mapsizey, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [mapsizey]
	gtk_widget_modify_font(pixelsizex, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [pixelsizex]
	gtk_widget_modify_font(pixelsizey, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [pixelsizey]
	gtk_widget_modify_font(category1, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category1]
	gtk_widget_modify_font(category2, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category2]
	gtk_widget_modify_font(category3, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category3]
	gtk_widget_modify_font(category4, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category4]

	//---------------------------------------------------------------------------------------//


	glade_xml_signal_autoconnect(xml);								// コールバック関数接続
	gtk_widget_show(window);									// ウィンドウ表示

	//---------------------------------------------------------------------------------------//


	//-- [ソケットディスクリプタ登録] -------------------------------------------------------//

	gdk_input_add(recv_sock, GDK_INPUT_READ, udp_read_callback, NULL);				// コールバック関数登録

	//---------------------------------------------------------------------------------------//


	//-- [イベントループ] -------------------------------------------------------------------//

	gtk_main();											// イベントループ

	//---------------------------------------------------------------------------------------//


	return 0;											// 戻り値 [正常終了]

}
//-----------------------------------------------------------------------------------------------//
