/************************************************************************************
dijkstrairs
Copyright (c) 2010, International Rescue System Institute
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD license.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/

//***********************************************************************************************//
//* dijk.cpp											*//
//***********************************************************************************************//


//-- [ヘッダファイル] ---------------------------------------------------------------------------//
#include "dijk.h"											// dijkヘッダファイル読み込み
//-----------------------------------------------------------------------------------------------//


//-- [シグナル処理関数] -------------------------------------------------------------------------//
//- void signal_handler_IO(int status)								-//
//- 機能  ：UDP/IPからの受信完了時フラグ変更							-//
//- 引数  ：(int)  シグナル									-//
//- 戻り値：(void) なし										-//
//-----------------------------------------------------------------------------------------------//
void signal_handler_IO(int status)
{

	wait_flag = 0;											// フラグリセット

	return;												// 戻り値

}
//-----------------------------------------------------------------------------------------------//


//-- [時間確認関数] -----------------------------------------------------------------------------//
//- double gettimeofday_sec(void)								-//
//- 機能  ：現在時刻の取得を行う								-//
//- 引数  ：(void)   なし									-//
//- 戻り値：(double) 現在時刻 [s]								-//
//-----------------------------------------------------------------------------------------------//
double gettimeofday_sec(void)
{

	// 変数宣言
	//
	// struct time{
	//	time_t tv_sec;			- 秒
	//	suseconds_t tv_usec;		- マイクロ秒
	// }
	//
	struct timeval tv;										// 使用されたユーザ時間格納構造体

	gettimeofday(&tv, NULL);									// 時刻取得

	return tv.tv_sec + (double)tv.tv_usec * 1e-6;							// 戻り値 [現在時刻]

}
//-----------------------------------------------------------------------------------------------//
